--Set base variables


pbjSettings = {};
pbjSettings.pbjScale = .6;
pbjSettings.slideOut = true;
pbjSettings.slideVisible = true;
pbjSettings.anchor = "LEFT";
pbjSettings.anchorY = 10;

local PBJ_OnUpdateInterval = 1.0;


local function pbjHeal_Cooldown(self)
	local cooldown = _G[self:GetName().."Cooldown"];
	local start, duration, enable = GetSpellCooldown(125439);
	CooldownFrame_Set(cooldown, start, duration, enable);
end

--Create main frame and events

local pbjf = CreateFrame("Frame","PetBattleJunkieFrame",UIParent);
pbjf:SetBackdrop({
	bgFile="Interface\\FrameGeneral\\UI-Background-Rock",
	edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
	tile=false, tileSize=24, edgeSize=24,
	insets={left=4, right=4, top=4, bottom=4}
});
pbjf:SetFrameStrata("HIGH");
pbjf:SetWidth(440);
pbjf:SetHeight(200);
pbjf:SetPoint(pbjSettings.anchor,UIParent,-10,pbjSettings.anchorY);
pbjf:SetScale(pbjSettings.pbjScale);
pbjf:EnableMouse(true);
pbjf:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then

	end
end)

local pbjheal = CreateFrame("Button","$parentHealPetButton", pbjf, "SecureActionButtonTemplate");

local spellName, spellSubname, spellIcon = GetSpellInfo(125439);
DEFAULT_CHAT_FRAME:AddMessage(spellName);
pbjheal:SetNormalTexture(spellIcon);
pbjheal:SetWidth(48);
pbjheal:SetHeight(48);
pbjheal:SetPoint("TOPLEFT",pbjf,15,-15);
pbjheal:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");

pbjheal:RegisterEvent("SPELL_UPDATE_COOLDOWN");
pbjheal:SetAttribute("type","spell")
pbjheal:SetAttribute("spell",spellName);
pbjheal.spellID = 125439;

pbjheal:SetScript("OnEvent", function (self,event,arg1)
	if ( event == "SPELL_UPDATE_COOLDOWN" ) then
		pbjHeal_Cooldown(self);
	end
end)

local cd = CreateFrame("Cooldown", "$parentCooldown", pbjheal, "CooldownFrameTemplate")
cd:SetAllPoints(true)
cd:Hide()

pbjheal.cooldown = cd;

local pbjBandage = CreateFrame("Button","$parentPetBandageButton", pbjf, "SecureActionButtonTemplate");
local _,_,_,_,_,_,_,_,_,itemTex,_ = GetItemInfo(86143);

pbjBandage:SetAttribute("type1", "item");
pbjBandage:SetNormalTexture(itemTex);
pbjBandage:SetAttribute("item1", "item:86143");
pbjBandage:SetWidth(48);
pbjBandage:SetHeight(48);
pbjBandage:SetPoint("TOPLEFT",pbjf,15,-76);
pbjBandage:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");


local pbjftb = CreateFrame("Button", "$parentToggleButton", pbjf);
pbjftb:SetNormalTexture("Interface\\RaidFrame\\RaidPanel-Toggle");
pbjftb:SetWidth(24);
pbjftb:SetHeight(80);
pbjftb:SetPoint("RIGHT",pbjf,-5,0);
pbjftb:SetScript("OnClick", function (self)
	if (pbjSettings.slideVisible) then
		pbjSettings.slideVisible = false;
		PetBattleJunkieFrame:SetPoint(pbjSettings.anchor,UIParent,-414,pbjSettings.anchorY);
		local tex = PetBattleJunkieFrameToggleButton:GetNormalTexture();
		tex:SetTexCoord(0, 0.5, 0, 1);
	else
		pbjSettings.slideVisible = true;
		PetBattleJunkieFrame:SetPoint(pbjSettings.anchor,UIParent,-10,pbjSettings.anchorY);
		local tex = PetBattleJunkieFrameToggleButton:GetNormalTexture();
		tex:SetTexCoord(0.5, 1, 0, 1);
	end
end);

local tex = pbjftb:GetNormalTexture();
tex:SetDrawLayer("OVERLAY")
tex:SetTexCoord(0.5, 1, 0, 1); --open


pbjftb:SetScript("OnMouseDown", function(self)
	local tex = self:GetNormalTexture();
	tex:ClearAllPoints();
	tex:SetSize(self:GetSize());
	tex:SetPoint("CENTER", 1, 0);
end);

pbjftb:SetScript("OnMouseUp", function(self)
	local tex = self:GetNormalTexture();
	tex:SetAllPoints();
end)

pbjf:RegisterEvent("PLAYER_LOGIN");
pbjf:RegisterEvent("PLAYER_ENTERING_WORLD");
pbjf:RegisterEvent("PET_JOURNAL_LIST_UPDATE");
pbjf:RegisterEvent("BATTLE_PET_CURSOR_CLEAR");
pbjf:RegisterEvent("PET_BATTLE_OVER");
pbjf:RegisterEvent("PET_BATTLE_OPENING_START");
pbjf:RegisterEvent("QUEST_LOG_UPDATE");
pbjf:RegisterEvent("MINIMAP_UPDATE_TRACKING");
pbjf:RegisterEvent("BAG_UPDATE");
pbjf:RegisterEvent("ADDON_LOADED");

pbjf:SetScript("OnEvent", function (self,event,arg1)
	if(event == "ADDON_LOADED") then
		if(pbjSettings.pbjScale == nil) then pbjSettings.pbjScale = .6; end
		if(pbjSettings.slideOut == nil) then pbjSettings.slideOut = true; end
		if(pbjSettings.slideVisible == nil) then pbjSettings.slideVisible = true; end
		if(pbjSettings.anchor == nil) then pbjSettings.anchor = "LEFT"; end
		if(pbjSettings.anchorY == nil) then pbjSettings.anchorY = 10; end
	end
	if(event == "BAG_UPDATE") then
		local _,_,_,_,_,_,_,_,_,itemTex,_ = GetItemInfo(86143);
		PetBattleJunkieFramePetBandageButton:SetNormalTexture(itemTex);
	end

	if(event == "PLAYER_LOGIN") then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF9922E3PetBattleJunkie|r loaded!");
		PetBattleJunkieFrame:SetScale(pbjSettings.pbjScale);
		pbjHeal_Cooldown(PetBattleJunkieFrameHealPetButton);
	end
	if (event=="PET_JOURNAL_LIST_UPDATE" or event=="BATTLE_PET_CURSOR_CLEAR") then
		UpdatePetFrames()
	end
	if (event=="PET_BATTLE_OVER") then
		UpdatePetFrames()
	end
	if (event=="PET_BATTLE_OPENING_START") then
		PetBattleJunkieFrame:SetScale(pbjSettings.pbjScale);
		if (pbjSettings.slideVisible) then
			PetBattleJunkieFrame:SetPoint(pbjSettings.anchor,UIParent,-414,pbjSettings.anchorY);
			local tex = PetBattleJunkieFrameToggleButton:GetNormalTexture();
			tex:SetTexCoord(0, 0.5, 0, 1);
		end
	end

end)

for i=1, 3 do
	CreatePetButton(i)
end